DECLARE SUB prt.XYZN3 ()
DECLARE SUB Ani.Tri.10 ()
DECLARE SUB Ani.Tri.00 ()
DECLARE SUB AT.Graph10.01 ()
DECLARE SUB AT.Graph11 ()
DECLARE SUB Ani.Tri.12 ()
DECLARE SUB AT.Graph10 ()
' A Proof of Fermat's Last Theorem - 28 Mar 95 ----- k. p. collins
DECLARE SUB Ani.Combo.min ()
DECLARE SUB Ani.Sqr.02 ()
DECLARE SUB Pause.Look3 ()
DECLARE SUB prt.Pyth ()
DECLARE SUB AT.Graph02 ()
DECLARE SUB Ani.cor.2 ()
DECLARE SUB cor.10.prt ()
DECLARE SUB cor.10 ()
DECLARE SUB Pause.Look2 ()
DECLARE SUB calcSign ()
DECLARE SUB AS.Graph02 ()
DECLARE SUB AT.Graph01 ()
DECLARE SUB Ani.Tri.01 ()
DECLARE SUB AST.scale ()
DECLARE SUB cor.11 ()
DECLARE SUB AS.Graph01 ()
DECLARE SUB Ani.Sqr.01 ()
DECLARE SUB A5.cor.01.prt ()
DECLARE SUB Pause.Check ()
DECLARE SUB A5.cor.01 ()
DECLARE SUB Ani.cor.5 ()
DECLARE SUB A4.cor.01.prt ()
DECLARE SUB A4.cor.01 ()
DECLARE SUB A.scale ()
DECLARE SUB A3.cor.01.prt ()
DECLARE SUB A3.cor.01 ()
DECLARE SUB Ani.cor.3 ()
DECLARE SUB Pause.Look ()
DECLARE SUB AC.cor.01.scales ()
DECLARE SUB AC.cor.01.init ()
DECLARE SUB AC.cor.04.scale ()
DECLARE SUB AC.cor.04 ()
DECLARE SUB AC.cor.03.scale ()
DECLARE SUB AC.cor.03 ()
DECLARE SUB AC.cor.02.scale ()
DECLARE SUB AC.cor.01.scale ()
DECLARE SUB Ani.cor.4 ()
DECLARE FUNCTION Log10! (l#)
DECLARE SUB AC.cor.02 ()
DECLARE SUB AC.cor.01.prt ()
DECLARE SUB AC.cor.01 ()
DECLARE SUB Ani.Combo.01 ()
DECLARE SUB cor.09.prt ()
DECLARE SUB cor.01.prt ()
DECLARE SUB prt.XYZN2 ()
DECLARE SUB cor.09 ()
DECLARE SUB Ani.Hyp ()
DECLARE SUB initialize ()
DECLARE SUB Explore04 ()
DECLARE SUB Graph04 ()
DECLARE SUB cor.08 ()
DECLARE SUB cor.07 ()
DECLARE SUB cor.05 ()
DECLARE SUB delay ()
DECLARE SUB cor.0a ()
DECLARE SUB calcSign ()
DECLARE SUB Ani.cor.1 ()
DECLARE SUB cor.04 ()
DECLARE SUB cor.03 ()
DECLARE SUB cor.02 ()
DECLARE SUB cor.01 ()
DECLARE SUB PlotHi ()
DECLARE SUB PlotLo ()
DECLARE SUB Graph03 ()
DECLARE SUB Explore03 ()
DECLARE SUB Graph01 ()
DECLARE SUB prt.hyp ()
DECLARE SUB calcHyp ()
DECLARE SUB prt.iteration ()
DECLARE SUB prt.zRatio ()
DECLARE SUB prt.Target ()
DECLARE SUB calc00 ()
DECLARE SUB prt.XYZN ()
DECLARE SUB PauseQ ()

OPTION BASE 1
DIM SHARED sign1.0(20, 2) AS DOUBLE, dSign1.0(20, 2) AS DOUBLE
DIM SHARED sign2.0(20, 2) AS DOUBLE, dSign2.0(20, 2) AS DOUBLE
DIM SHARED sign3.0(20, 2) AS DOUBLE, dSign3.0(20, 2) AS DOUBLE
DIM SHARED sign(20) AS DOUBLE
COMMON SHARED begin
COMMON SHARED x AS INTEGER, y AS INTEGER, z AS INTEGER, n AS INTEGER
COMMON SHARED xn AS DOUBLE, yn AS DOUBLE, zn AS DOUBLE
COMMON SHARED xscale AS LONG, yscale AS LONG, targ#
COMMON SHARED leftpart AS DOUBLE, iteration AS DOUBLE, pchoice AS INTEGER
COMMON SHARED dSign1 AS DOUBLE, dSign2 AS DOUBLE, dSign3 AS DOUBLE
COMMON SHARED dSign1.min AS DOUBLE, dSign2.min AS DOUBLE, dSign3.min AS DOUBLE
COMMON SHARED area.r AS DOUBLE, side.r AS DOUBLE, hyp.r AS DOUBLE
COMMON SHARED area.l AS DOUBLE, side.l AS DOUBLE, hyp.l AS DOUBLE
COMMON SHARED ratio.r AS DOUBLE, ratio.l AS DOUBLE, ratio.w AS DOUBLE
COMMON SHARED area.w AS DOUBLE, side.w AS DOUBLE, hyp.w AS DOUBLE
COMMON SHARED attr.z AS INTEGER, attr.h AS INTEGER, attr.n AS INTEGER
COMMON SHARED attr.ws AS INTEGER, attr.hw AS INTEGER, attr.sl AS INTEGER
COMMON SHARED attr.ratio AS INTEGER, attr.eq AS INTEGER, attr.sr AS INTEGER
COMMON SHARED attr.ratio.p, attr.h.p, attr.ws.p, attr.hw.p
COMMON SHARED attr AS INTEGER, v AS INTEGER, m AS INTEGER, start%, finish%

initialize

begin:

VIEW PRINT 1 TO 60

'in all steps, wait for the "e" in the upper-right corner of screen

'uncomment steps below to view each - do one at a "time" because some can
'run relatively long

'  also, in each step there are other viewing choices you can make
'  hit <F2> to get the subprogram menu, cursor to subprogram (hitting
'  first letter is a short-cut), and hit <Enter> to view subprogram code
'  or double click on a subprogram name to high light it in the code and
'  hit F2 and you'll go to that subprogram

'  add pause queries (PauseQ) where you want to pause program execution

' -------------------------- executable steps -------------------------------

  Graph04        'graph of FLT hyp dynamics for n=1 to 5 at various scales
'  Ani.Tri.10     'shows the basic paradigm of the FLT Proof - Triangle
'  Ani.Tri.12     'same as Ani.Tri.10, but 3,4,5 Triangles only
'  Ani.Sqr.01     'shows the basic paradigm of the FLT Proof - Square
'  Ani.Sqr.02     'like Ani.Sqr.01 but does the higher n "triangle" looking
'  Ani.Tri.01     'Incomplete, but interesting; note n=2 difference - Triangle
'  Explore03      'numeric + 'no numbers' displays of FTL dynamics
'  Explore04      'like Explore03, but automated, and print only on left=right
'  Ani.Hyp        'like Explore04, but hyp-ratio 'wave' graphics
'  Graph01        'graph of FLT hypotenuse dynamics - varies z last
'  Graph03        'graph of FLT hypotenuse dynamics - varies z first
'  Ani.cor.1      'animation of FLT hypotenuse 'flirtation' with Unity
'  Ani.cor.2      'like Ani.Hyp, but smoothe-line-overlay point graphics
'  Ani.cor.3      'like Ani.Hyp, but point-overlay point graphics
'  Ani.cor.4      'like Ani.cor.3, but graphics that focus on 'sign(2)' inflections
'  Ani.cor.5      'like Ani.cor.3, but graphics that focus on 'sign(3)' small scale
'  Ani.Combo.01   'combined Ani.cor.3, 4, 5 & 6
'  Ani.Combo.min  'similar to Ani.Combo.01, but no graphics - prints dSign
                  'minima, verifies 1-ratio & asymptotic behaviors

GOTO begin

END

SUB A.scale

SELECT CASE finish%

   CASE IS = 5
      xscale = 25
   CASE IS = 10
      xscale = 65
   CASE IS = 15
      xscale = 95
   CASE IS = 20
      xscale = 125
   CASE ELSE
      xscale = 500

END SELECT

VIEW (400, 10)-(600, 435), , 8

END SUB

SUB A3.cor.01

   'A.scale

SELECT CASE finish%

   CASE IS = 5
      xscale = 35
   CASE IS = 10
      xscale = 65
   CASE IS = 15
      xscale = 95
   CASE IS = 20
      xscale = 125
   CASE ELSE
      xscale = 500

END SELECT

VIEW (400, 10)-(600, 435), , 8

   WINDOW (0, 0)-(xscale, 2)

   LINE (0, targ#)-(xscale / 25, targ#), 8
   LINE (xscale, targ#)-(xscale - (xscale / 25), targ#), 8

   PSET (sign1.0(y, 1), sign1.0(y, 2)), 0
   PSET (sign2.0(y, 1), sign2.0(y, 2)), 0

   'delay                               'uncomment if you have a fast machine

   PSET (y + v, sign(1)), 12
   PSET (y + v, sign(2)), attr.ratio.p + 8

   'delay                               'uncomment if you have a fast machine

   sign1.0(y, 1) = y + v: sign1.0(y, 2) = sign(1)
   sign2.0(y, 1) = y + v: sign2.0(y, 2) = sign(2)

'   dSign1.0(y, 1) = y + v: dSign1.0(y, 2) = dSign1
'   dSign2.0(y, 1) = y + v: dSign2.0(y, 2) = dSign2

'   COLOR (8)

'   IF dSign1 < dSign1.min THEN dSign1.min = dSign1
'   IF dSign2 < dSign2.min THEN dSign2.min = dSign2

   v = v + 5

VIEW (0, 0)-(235, 479)
A3.cor.01.prt
COLOR (8)

END SUB

SUB A3.cor.01.prt

LOCATE 1, 55: COLOR (8): PRINT "correlations"
LOCATE 58, 58: COLOR (4): PRINT "s1  "; : COLOR (7): PRINT "s2..."

END SUB

SUB A4.cor.01

   A.scale

   WINDOW (0, 0)-(xscale, targ#)

   'for an overall picture of the way the numbers
   'work change ------------------------- v to 1
   PSET (dSign1.0(y, 1), dSign1.0(y, 2)), 0
   PSET (dSign2.0(y, 1), dSign2.0(y, 2)), 0

   'delay
   PSET (y + v, dSign1), 13
   PSET (y + v, dSign2), 11

   'delay

   dSign1.0(y, 1) = y + v: dSign1.0(y, 2) = dSign1
   dSign2.0(y, 1) = y + v: dSign2.0(y, 2) = dSign2

   IF dSign1 < dSign1.min THEN dSign1.min = dSign1
   IF dSign2 < dSign2.min THEN dSign2.min = dSign2

   sign1.0(y, 1) = y + v: sign1.0(y, 2) = sign(1)
   sign2.0(y, 1) = y + v: sign2.0(y, 2) = sign(2)

   v = v + 5

VIEW (0, 0)-(235, 479)
A4.cor.01.prt
COLOR (8)

END SUB

SUB A4.cor.01.prt

LOCATE 1, 55: COLOR (8): PRINT "correlations"
LOCATE 59, 58: COLOR (5): PRINT "dS1 "; : COLOR (3): PRINT "dS2..."

END SUB

SUB A5.cor.01

   A.scale

   WINDOW (0, 0)-(xscale, 10)

   'for an overall picture of the way the numbers work change ---- v to 1
   PSET (sign3.0(y, 1), sign3.0(y, 2)), 0
   PSET (dSign3.0(y, 1), dSign3.0(y, 2)), 0

   PSET (y + v, sign(3)), attr.ratio.p + 8
   PSET (y + v, dSign3), 12

   dSign3.0(y, 1) = y + v: dSign3.0(y, 2) = dSign3

   IF dSign3 < dSign3.min THEN dSign3.min = dSign3

   sign3.0(y, 1) = y + v: sign3.0(y, 2) = sign(3)

   v = v + 5

VIEW (0, 0)-(235, 479)
A5.cor.01.prt
COLOR (8)

END SUB

SUB A5.cor.01.prt

LOCATE 1, 55: COLOR (8): PRINT "correlations"
LOCATE 58, 58: COLOR (7): PRINT "s3  "; : COLOR (9): PRINT "dS3..."

END SUB

SUB AC.cor.01

VIEW (300, 10)-(500, 230), , 8

   WINDOW (0, 0)-(xscale, 2 * targ#)

   PSET (sign1.0(y, 1), sign1.0(y, 2)), 0
   PSET (y + v, sign(1)), 12

   'delay                       'uncomment if you have a fast machine

   PSET (sign2.0(y, 1), sign2.0(y, 2)), 0
   PSET (y + v, sign(2)), attr.ratio.p + 8

END SUB

SUB AC.cor.01.init

VIEW
CLS
VIEW (95, 10)-(295, 230), , 8
CLS
VIEW (95, 235)-(295, 435), , 8
CLS
VIEW (300, 10)-(500, 230), , 8
CLS
VIEW (300, 235)-(500, 435), , 8
CLS
AC.cor.01.scales
AC.cor.01.prt

END SUB

SUB AC.cor.01.prt

LOCATE 1, 13: COLOR (8): PRINT "correlations"
LOCATE 58, 47: COLOR (4): PRINT "s1  "; : COLOR (7): PRINT "s2..."
LOCATE 59, 47: COLOR (5): PRINT "dS1 "; : COLOR (3): PRINT "dS2..."

LOCATE 58, 22: COLOR (7): PRINT "s3  "; : COLOR (9): PRINT "dS3..."
LOCATE 59, 22: COLOR (7): PRINT "s3  "; : COLOR (9): PRINT "dS3..."

END SUB

SUB AC.cor.01.scale

LOCATE 2, 65: COLOR (8): PRINT "2"
LOCATE 16, 65: COLOR (8): PRINT "1"
LOCATE 29, 65: COLOR (8): PRINT "0"

SELECT CASE finish%

   CASE IS = 5
      xscale = 35
   CASE IS = 10
      xscale = 65
   CASE IS = 15
      xscale = 95
   CASE IS = 20
      xscale = 125
   CASE ELSE
      xscale = 125

END SELECT

VIEW (300, 10)-(500, 230), , 8

   WINDOW (0, 0)-(xscale, 2 * targ#)

   LINE (0, targ#)-(xscale / 25, targ#), 8
   LINE (xscale, targ#)-(xscale - (xscale / 25), targ#), 8

END SUB

SUB AC.cor.01.scales

   COLOR (8)
   LOCATE 1, 36: PRINT "n ="; n
   dSign1.min = 10: dSign2.min = 10

   AC.cor.01.scale
   AC.cor.02.scale
   AC.cor.03.scale
   AC.cor.04.scale

END SUB

SUB AC.cor.02

VIEW (300, 235)-(500, 435), , 8

   WINDOW (0, 0)-(xscale, targ#)

   PSET (dSign1.0(y, 1), dSign1.0(y, 2)), 0
   PSET (y + v, dSign1), 13

   'delay

   PSET (dSign2.0(y, 1), dSign2.0(y, 2)), 0
   PSET (y + v, dSign2), 11

   'delay

END SUB

SUB AC.cor.02.scale

COLOR (8)
LOCATE 30, 65: PRINT "1"
LOCATE 55, 65: PRINT "0"

VIEW (300, 235)-(500, 435), , 8

   WINDOW (0, 0)-(xscale, targ#)

END SUB

SUB AC.cor.03

VIEW (95, 10)-(295, 230), , 8

   WINDOW (0, 0)-(xscale, 1000)

   IF sign3.0(y, 2) <> 1 THEN PSET (sign3.0(y, 1), sign3.0(y, 2)), 0
   PSET (y + v, sign(3)), attr.ratio.p + 8

   PSET (dSign3.0(y, 1), dSign3.0(y, 2)), 0
   PSET (y + v, dSign3), 10

END SUB

SUB AC.cor.03.scale

COLOR (8)
LOCATE 2, 8: PRINT "1000"
LOCATE 29, 11: PRINT "0"

END SUB

SUB AC.cor.04

VIEW (95, 235)-(295, 435), , 8

   WINDOW (0, 0)-(xscale, 5)

   PSET (sign3.0(y, 1), sign3.0(y, 2)), 0
   PSET (y + v, sign(3)), attr.ratio.p + 8

   PSET (dSign3.0(y, 1), dSign3.0(y, 2)), 0
   PSET (y + v, dSign3), 10

   dSign1.0(y, 1) = y + v: dSign1.0(y, 2) = dSign1
   dSign2.0(y, 1) = y + v: dSign2.0(y, 2) = dSign2
   dSign3.0(y, 1) = y + v: dSign3.0(y, 2) = dSign3

   COLOR (8)

   IF dSign1 < dSign1.min THEN dSign1.min = dSign1
   IF dSign2 < dSign2.min THEN dSign2.min = dSign2
   IF dSign3 < dSign3.min THEN dSign3.min = dSign3

   sign1.0(y, 1) = y + v: sign1.0(y, 2) = sign(1)
   sign2.0(y, 1) = y + v: sign2.0(y, 2) = sign(2)
   sign3.0(y, 1) = y + v: sign3.0(y, 2) = sign(3)

   v = v + 5

END SUB

SUB AC.cor.04.scale

COLOR (8)
LOCATE 30, 11: PRINT "5"
LOCATE 50, 11: PRINT "1"
LOCATE 55, 11: PRINT "0"

VIEW (95, 235)-(295, 435), , 8

   WINDOW (0, 0)-(xscale, 5)

   LINE (0, targ#)-(xscale / 25, targ#), 8
   LINE (xscale, targ#)-(xscale - (xscale / 25), targ#), 8

END SUB

SUB Ani.Combo.01
SHARED XX, YY, zz, nn

iteration = 0: m = 0

'start% = 1: finish% = 5
start% = 1: finish% = 10

' if you have a fast machine... (or a lot of patience :-)
'start% = 2: finish% = 15
'start% = 2: finish% = 20

AC.cor.01.init
FOR n = start% TO finish%
   PauseQ
   AC.cor.01.scales

   FOR z = start% TO finish%
      v = 5                        'used in graphics windows

      FOR x = start% TO finish%
         v = 5

         IF pausit = 1 THEN
            pausit = 0
            PauseQ
            AC.cor.01.prt
         END IF

         FOR y = start% TO finish%

         calc00
         calcHyp
         calcSign

         AC.cor.01
         AC.cor.02
         AC.cor.03
         AC.cor.04

         ' uncomment block to stop at left = right instances during loop
         IF leftpart = zn THEN pausit = 1: XX = x: YY = y: zz = z: nn = n

         attr.ratio.p = 7
         NEXT

      'uncomment if you have a fast machine
      'delayit

      NEXT
   NEXT

'AC.cor.01m ' substitute do domething each cycle
NEXT

PauseQ

END SUB

SUB Ani.Combo.min

iteration = 0

'start% = 1: finish% = 5
'start% = 1: finish% = 10

' if you have a fast machine... (or a lot of patience :-)
start% = 2: finish% = 15
'start% = 2: finish% = 20
'start% = 3: finish% = 100  'I've only been able to let this run for n = 3

FOR n = start% TO finish%
   PauseQ
   COLOR (8)
   LOCATE 1, 36: PRINT "n ="; n
   dSign1.min = 10: dSign2.min = 10

   FOR z = start% TO finish%
      FOR x = start% TO finish%
         FOR y = start% TO finish%

         calc00
         calcHyp
         calcSign
        
         IF dSign1 < dSign1.min THEN
            dSign1.min = dSign1
            COLOR (7)
            LOCATE 11, 1: PRINT "                          "
            LOCATE 11, 1: PRINT dSign1.min
         END IF
         IF dSign2 < dSign2.min THEN
            dSign2.min = dSign2
            COLOR (5)
            LOCATE 12, 1: PRINT "                          "
            LOCATE 12, 1: PRINT dSign2.min
         END IF

         NEXT
      NEXT
   NEXT
NEXT

PauseQ

END SUB

SUB Ani.cor.1

CLS : iteration = 0

start% = 1: finish% = 5: attr = 7

FOR z = start% TO finish%
   FOR x = start% TO finish%
      FOR y = start% TO finish%
         FOR n = finish% TO start% STEP -1

            calc00
            calcHyp
            calcSign
            cor.0a
         NEXT
      NEXT
   NEXT
NEXT

PauseQ
END SUB

SUB Ani.cor.2
SHARED XX, YY, zz, nn, pausit

iteration = 0: pchoice = 2

'start% = 1: finish% = 5
start% = 1: finish% = 10
'start% = 2: finish% = 15
'start% = 2: finish% = 20

cor.10.prt
FOR n = start% TO finish%
   COLOR (8): LOCATE 2, 22: PRINT "n ="; n: COLOR (7)
         dSign1.min = 10: dSign2.min = 10

   FOR z = start% TO finish%
      v = 5                        'used in graphics window

      FOR x = start% TO finish%
         v = 5
         IF pausit = 1 THEN
            pausit = 0
            prt.XYZN
            PauseQ
            CLS
            COLOR (8): LOCATE 2, 22: PRINT "n ="; n: COLOR (7)
         END IF

         FOR y = start% TO finish%
            calc00
            calcHyp
            calcSign
            cor.10

            'set the 'Pause.Check sub-program calls to your taste
'            Pause.Check
         ' uncomment block to stop at left = right instances during loop
         IF leftpart = zn THEN pausit = 1: XX = x: YY = y: zz = z: nn = n

            attr.ratio.p = 7
         NEXT
      NEXT
   NEXT
PauseQ
NEXT

PauseQ

END SUB

SUB Ani.cor.3
SHARED XX, YY, zz, nn, pausit

iteration = 0: pchoice = 2

'start% = 1: finish% = 5
start% = 2: finish% = 10

' if you have a fast machine... (or a lot of patience :-)
'start% = 2: finish% = 15
'start% = 2: finish% = 20

FOR n = start% TO finish%
   PauseQ
   COLOR (8): LOCATE 2, 22: PRINT "n ="; n: COLOR (7)
   FOR z = start% TO finish%
      COLOR (8)
      dSign1.min = 10: dSign2.min = 10

      FOR x = start% TO finish%
         v = 5

         IF pausit = 1 THEN
            pausit = 0
            prt.XYZN
            PauseQ
            CLS
            A3.cor.01.prt
         END IF

         FOR y = start% TO finish%

         calc00
         calcHyp
         calcSign
         A3.cor.01

         IF leftpart = zn THEN XX = x: YY = y: zz = z: nn = n: pausit = 1

         attr.ratio.p = 7
         NEXT

      'uncomment if you have a fast machine
      'delayit

      NEXT
   NEXT

'AC.cor.01m ' substitute do domething each cycle
NEXT

PauseQ

END SUB

SUB Ani.cor.4
SHARED XX, YY, zz, nn, pausit

iteration = 0: m = 0

'start% = 1: finish% = 5
start% = 1: finish% = 10

' if you have a fast machine... (or a lot of patience :-)
'start% = 2: finish% = 15
'start% = 2: finish% = 20

FOR n = start% TO finish%
   PauseQ
   COLOR (8): LOCATE 2, 22: PRINT "n ="; n: COLOR (7)

   FOR z = start% TO finish%
      v = 5                        'used in graphics windows
      COLOR (8)
      dSign1.min = 10: dSign2.min = 10

      FOR x = start% TO finish%
         v = 5

         IF pausit = 1 THEN
            pausit = 0
            prt.XYZN2
            PauseQ
            CLS
            A4.cor.01.prt
         END IF

         FOR y = start% TO finish%

         calc00
         calcHyp
         calcSign
         A4.cor.01

         IF leftpart = zn THEN XX = x: YY = y: zz = z: nn = n: pausit = 1

         attr.ratio.p = 7
         NEXT

      'uncomment if you have a fast machine
      'delayit

      NEXT
   NEXT

'AC.cor.01m ' substitute do domething each cycle
NEXT

PauseQ

END SUB

SUB Ani.cor.5
SHARED XX, YY, zz, nn, pausit

iteration = 0: m = 0

'start% = 1: finish% = 5
start% = 1: finish% = 10

' if you have a fast machine... (or a lot of patience :-)
'start% = 2: finish% = 15
'start% = 2: finish% = 20

FOR n = start% TO finish%
   PauseQ
   COLOR (8): LOCATE 2, 22: PRINT "n ="; n: COLOR (7)

   FOR z = start% TO finish%
      v = 5                        'used in graphics windows
      COLOR (8)
      dSign1.min = 10: dSign2.min = 10

      FOR x = start% TO finish%
         v = 5

         IF pausit = 1 THEN
            pausit = 0
            prt.XYZN2
            PauseQ
            CLS
            A5.cor.01.prt
         END IF

         FOR y = start% TO finish%

         calc00
         calcHyp
         calcSign
         A5.cor.01

         IF leftpart = zn THEN XX = x: YY = y: zz = z: nn = n: pausit = 1

         attr.ratio.p = 7
         NEXT

      'uncomment if you have a fast machine
      'delayit

      NEXT
   NEXT

'AC.cor.01m ' substitute do domething each cycle
NEXT

PauseQ

END SUB

SUB Ani.cor.6
END SUB

SUB Ani.Hyp

iteration = 0

start% = 1: finish% = 10

cor.09.prt
FOR n = start% TO finish%
   COLOR (8): LOCATE 2, 22: PRINT "n ="; n: COLOR (7)

   FOR z = start% TO finish%
      v = 0
      FOR x = start% TO finish%
         v = 0
         FOR y = start% TO finish%

         calc00
         calcHyp
         calcSign
         cor.09

         ' uncomment block to stop at = instances during loop
'         IF leftpart = zn THEN
'            prt.xyzn
'            prt.hyp
'            prt.Target
'            prt.zRatio
'            prt.iteration
'            PauseQ
'            CLS
'            cor.09.prt
'         END IF

          'pause at every instance - no print - do some of this at least once
'         PauseQ
          attr.ratio.p = 7
         NEXT
      NEXT
   NEXT
NEXT

PauseQ

END SUB

SUB Ani.Sqr.01
SHARED XX, YY, zz, nn, pausit

'set the 'Pause.Check' sub-program calls as you like
pchoice = 1 '0 no pause; 1 always; 2 on left = right

iteration = 0: m = 0

start% = 1: finish% = 5

'FOR n = 10 TO 10   'set n=? for individual series
'FOR n = 5 TO finish%   'set n=? for individual series
FOR n = start% TO finish%
   PauseQ
   COLOR (8): LOCATE 2, 22: PRINT "n ="; n: COLOR (7)

   FOR z = start% TO finish%
      FOR x = start% TO finish%

         IF pausit = 1 THEN
            pausit = 0
            prt.XYZN2
            PauseQ
            CLS
            'A3.cor.01.prt
         END IF

         FOR y = start% TO finish%

         calc00
         calcHyp
         calcSign
'         IF leftpart = zn THEN
            VIEW (420, 10)-(620, 210), , 8
               AS.Graph01
'         END IF

'         Pause.Look2
         Pause.Check

         attr.ratio.p = 7
         NEXT

      NEXT
   NEXT

'AC.cor.01m ' substitute do domething each cycle
NEXT

PauseQ

END SUB

SUB Ani.Sqr.02
SHARED XX, YY, zz, nn, pausit

'set the 'Pause.Check' sub-program calls as you like
pchoice = 3 '0 no pause; 1 always; 2 on left = right

iteration = 0: m = 0

start% = 1: finish% = 5

FOR n = 5 TO finish%   'set n=? for indivicual series
'FOR n = start% TO finish%
   PauseQ
   COLOR (8): LOCATE 2, 22: PRINT "n ="; n: COLOR (7)

   FOR z = start% TO finish%
      FOR x = start% TO finish%

         IF pausit = 1 THEN
            pausit = 0
            prt.XYZN2
            PauseQ
            CLS
            'A3.cor.01.prt
         END IF

         FOR y = start% TO finish%

         calc00
         calcHyp
         calcSign
         VIEW (420, 10)-(620, 210), , 8
               AS.Graph01

         Pause.Look3
'         prt.Pyth
         Pause.Check

         attr.ratio.p = 7
         NEXT

      NEXT
   NEXT

NEXT

PauseQ

END SUB

SUB Ani.Tri.00

AT.Graph10.01

VIEW (420, 10)-(620, 210), , 8

AT.Graph10

prt.XYZN3

PauseQ

IF begin = 1 THEN EXIT SUB

VIEW (375, 10)-(395, 435), , 8
CLS
VIEW (400, 10)-(415, 435), , 8
CLS
VIEW (420, 235)-(620, 435), , 14
CLS
VIEW (420, 10)-(620, 210), , 8
CLS
VIEW (0, 0)-(370, 400)
CLS

END SUB

SUB Ani.Tri.01
SHARED XX, YY, zz, nn, pausit

'set the 'Pause.Check' sub-program calls as you like
pchoice = 2 '0 no pause; 1 always; 2 on left = right

iteration = 0: m = 0

start% = 1: finish% = 10

'FOR n = 5 TO finish%
FOR n = start% TO finish%
   PauseQ
   COLOR (8): LOCATE 2, 22: PRINT "n ="; n: COLOR (7)

   FOR z = start% TO finish%
      FOR x = start% TO finish%
         FOR y = start% TO finish%

         calc00
         calcHyp
         calcSign
         VIEW (420, 10)-(620, 210), , 8
         IF leftpart = zn THEN
            AT.Graph02
            Pause.Look
            IF begin = 1 THEN EXIT SUB
            CLS
         END IF

         attr.ratio.p = 7
         NEXT

      NEXT
   NEXT

'AC.cor.01m ' substitute do domething each cycle
NEXT

PauseQ

END SUB

SUB Ani.Tri.10

iteration = 0: m = 0
start% = 1: finish% = 5

FOR n = start% TO finish%
   COLOR (8): LOCATE 2, 22: PRINT "n ="; n: COLOR (7)
   PauseQ
   FOR z = start% TO finish%
      FOR x = start% TO finish%
         FOR y = start% TO finish%

          calc00

'         IF leftpart = zn THEN
            Ani.Tri.00
'         END IF

         NEXT
      NEXT
   NEXT
NEXT

PauseQ

END SUB

SUB Ani.Tri.12

iteration = 0: m = 0

x = 3: y = 4: z = 5

start% = 1: finish% = 20

FOR n = start% TO finish%
   COLOR (8): LOCATE 2, 22: PRINT "n ="; n: COLOR (7)

   calc00

'   IF leftpart = zn THEN
      Ani.Tri.00
'   END IF

NEXT

PauseQ

END SUB

SUB AS.Graph01
SHARED xl, yl, offset1#, remain.l#, remain.r#

xscale = (1.1 * hyp.w)

offset% = 50
xl = xscale / offset%
yl = xscale / offset%
offset1# = xl / (offset% / n)

   CLS    'VIEW set in calling routine

   WINDOW (0, 0)-(xscale, xscale)

   LINE (xl, yl)-(xl + side.l, (yl + side.l)), 7               'left hyp
   LINE (xl, yl + side.l)-(xl + side.l, yl + side.l), attr.sl 'left horiz
   remain.l# = 2 * side.l - INT(2 * side.l)
   LINE (xl + side.l - remain.l#, yl + side.l)-(xl + side.l, yl + side.l), 8
   LINE (xl, yl)-(xl, yl + side.l), attr.sl                     'left vert

   LINE (xl, yl)-(xl + side.r, (yl + side.r)), 2               'right hyp
   LINE (xl, yl)-(xl + side.r, yl), attr.sr                     'right horiz
   LINE (xl + side.r, yl)-(xl + side.r, yl + side.r), attr.sr 'right vert
   remain.r# = 2 * side.r - INT(2 * side.r)
   LINE (xl + side.r, yl + side.r - remain.r#)-(xl + side.r, yl + side.r), 8'right vert

   IF pchoice > 0 AND pchoice < 4 THEN 'draw inset for AS.Graph02
      IF side.l <= side.r THEN
         LINE (side.l, side.l)-(side.l + xl + xl, side.l + yl + yl), 14, B
      ELSE
         LINE (side.r, side.r)-(side.r + xl + xl, side.r + yl + yl), 14, B
      END IF
      AS.Graph02
   END IF

VIEW (0, 0)-(235, 479)
'AS.cor.01.prt                   'diagram legend
COLOR (8)

END SUB

SUB AS.Graph02
SHARED xl, yl, offset1#, remain.l#, remain.r#

VIEW (420, 235)-(620, 435), , 14
   CLS

IF side.l <= side.r THEN
   WINDOW (side.l, side.l)-(side.l + xl + xl, side.l + yl + yl)
ELSE
   WINDOW (side.r, side.r)-(side.r + xl + xl, side.r + yl + yl)
END IF

   LINE (xl, yl)-(xl + side.l, (yl + side.l)), 7               'left hyp
   LINE (xl, yl + side.l)-(xl + side.l, yl + side.l), attr.sl 'left horiz
   LINE (xl + side.l - remain.l#, yl + side.l)-(xl + side.l, yl + side.l), 8
   LINE (xl, yl)-(xl, yl + side.l), attr.sl                     'left vert

   LINE (xl, yl)-(xl + side.r, (yl + side.r)), 2               'right hyp
   LINE (xl, yl)-(xl + side.r, yl), attr.sr                     'right horiz
   LINE (xl + side.r, yl)-(xl + side.r, yl + side.r), attr.sr 'right vert
   LINE (xl + side.r, yl + side.r - remain.r#)-(xl + side.r, yl + side.r), 8'right vert

END SUB

SUB AT.Graph02
SHARED xl, yl, remain.h#

LOCATE 28, 54: COLOR (14): PRINT "this is still exploratory": COLOR (7)

IF zn >= leftpart THEN
   xscale = (1.25 * z)
ELSE
   xscale = (1.25 * SQR(x ^ 2 + y ^ 2))
END IF

offset% = 50: xl = xscale / offset%: yl = xscale / offset%

   CLS          'VIEW set in calling routine

   WINDOW (0, 0)-(xscale, xscale)

   LINE (xl, yl)-(xscale, yl), 8
   LINE (xl + x, yl)-(xl + x, xscale), 8

   LINE (xl, yl)-(xl + x, (yl + y)), 8                  'hyp - left-based
   LINE (xl, yl)-(xl + x, yl), attr.sl                  'x
   LINE (xl + x, yl)-(xl + x, yl + y), attr.sl          'y

   tanTheta# = ATN(y / x)
   x.z# = z * COS(tanTheta#)
   y.z# = z * SIN(tanTheta#)

   LOCATE 56, 1: PRINT "  a ="; x * y / 2
   LOCATE 57, 1: PRINT "a.z ="; x.z# * y.z# / 2
   LOCATE 58, 1: PRINT "x.z ="; x.z#
   LOCATE 59, 1: PRINT "y.z ="; y.z#

   LINE (xl + x.z#, yl)-(xl + x.z#, xscale), 8

   LINE (xl, yl)-(xl + x.z#, (yl + y.z#)), 2            'hyp - right-based
   LINE (xl, yl)-(xl + x.z#, yl), attr.sr               'x
   LINE (xl + x.z#, yl)-(xl + x.z#, yl + y.z#), attr.sr 'y

'   IF pchoice > 0 AND pchoice < 3 THEN
'      IF side.l <= side.r THEN
'         LINE (side.l, side.l)-(side.l + xl + xl, side.l + yl + yl), 14, B
'      ELSE
'         LINE (side.r, side.r)-(side.r + xl + xl, side.r + yl + yl), 14, B
'      END IF
'      AS.Graph02
'   END IF

VIEW (0, 0)-(235, 479)
'AS.cor.01.prt                   'diagram legend
COLOR (8)

END SUB

SUB AT.Graph10
SHARED xl, yl, x.z#, y.z#

IF zn >= leftpart THEN
   xscale = (1.25 * z)
ELSE
   xscale = (1.25 * SQR(x ^ 2 + y ^ 2))
END IF

offset% = 50: xl = xscale / offset%: yl = xscale / offset%

   tanTheta# = ATN(y / x)
   x.z# = z * COS(tanTheta#)
   y.z# = z * SIN(tanTheta#)

   CLS          'VIEW set in calling routine

   WINDOW (0, 0)-(xscale, xscale)

   LOCATE 15, 1: PRINT "x.z# ="; x.z#
   PRINT "y.z# ="; y.z#
   PRINT "(xl + x) + x.z# ="; (xl + x) + x.z#

   LINE (xl, yl)-(xl + x.z#, (yl + y.z#)), 2
   LINE (xl, yl)-(xl + x, yl), 4
   LINE (xl + x, yl)-(xl + x, yl + y), 3

   LINE (-xl / 3 + x, -yl / 3 + y)-(2 * xl + x, 2 * yl + y), 14, B

   AT.Graph11

COLOR (8)

END SUB

SUB AT.Graph10.01

zoom# = 0
IF x + y >= z THEN
   zoom# = x + y
ELSE
   zoom# = z
END IF
v = 5

VIEW (375, 10)-(395, 435), , 8
   CLS
   WINDOW (0, 0)-(15, zoom#)

   LINE (v, 0)-(v, x), 4
   LINE (v, x)-(v, x + y), 3
   v = v + 5
   LINE (v, 0)-(v, z), 2

zoom# = 0
IF leftpart >= zn THEN
   zoom# = leftpart
ELSE
   zoom# = zn
END IF
v = 5

VIEW (400, 10)-(415, 435), , 8
   CLS
   WINDOW (0, 0)-(15, zoom#)
   LINE (v, 0)-(v, leftpart), 7
   v = v + 5
   LINE (v, 0)-(v, zn), 5

LOCATE 56, 47: COLOR (4): PRINT "x";
COLOR (7): PRINT "+"; : COLOR (3): PRINT "y "; : COLOR (7): PRINT "lft"
LOCATE 57, 47: COLOR (2): PRINT "  z "; : COLOR (5): PRINT "rgt"
COLOR (7)

END SUB

SUB AT.Graph11
SHARED xl, yl, x.z#, y.z#

VIEW (420, 235)-(620, 435), , 14
   CLS

   WINDOW (-xl / 3 + x, -yl / 3 + y)-(2 * xl + x, 2 * yl + y)

   LINE (xl, yl)-(xl + x.z#, (yl + y.z#)), 2
   LINE (xl, yl)-(xl + x, yl), 4
   LINE (xl + x, yl)-(xl + x, yl + y), 3

END SUB

SUB calc00

iteration = iteration + 1
xn = x ^ n
yn = y ^ n
zn = z ^ n
leftpart = xn + yn

END SUB

SUB calcHyp

area.r = zn
side.r = SQR(2 * area.r) 'virtual side of left triangle
hyp.r = SQR((side.r ^ 2) + (side.r ^ 2))
ratio.r = side.r / hyp.r

area.l = leftpart
side.l = SQR(2 * leftpart) 'virtual side of left triangle
hyp.l = SQR((side.l ^ 2) + (side.l ^ 2))
ratio.l = side.l / hyp.l

area.w = area.r + area.l
side.w = SQR(area.w)
hyp.w = SQR((side.w ^ 2) + (side.w ^ 2))
ratio.w = side.w / hyp.w

IF hyp.r = hyp.l THEN attr.h.p = attr.h ELSE attr.h.p = 7

END SUB

SUB calcSign

sign(1) = hyp.l / hyp.w
dSign1 = ABS(sign(1) - targ#)

sign(2) = hyp.r / hyp.w
dSign2 = ABS(sign(2) - targ#)

sign(3) = sign(2) / sign(1)
dSign3 = ABS(sign(3) - targ#)

sign(4) = sign(1) / sign(2)
sign(5) = hyp.l / hyp.r
sign(6) = hyp.r / hyp.l

sign(7) = x / hyp.l
sign(8) = x / hyp.r
sign(9) = x / hyp.w

sign(10) = z / hyp.l
sign(11) = z / hyp.r
sign(12) = z / hyp.w

sign(13) = y / hyp.l
sign(14) = y / hyp.r
sign(15) = y / hyp.w

IF sign(1) = targ# THEN
   attr.ratio.p = attr.ratio
ELSE
   attr.ratio.p = 7
END IF

COLOR (7)

END SUB

SUB cor.01

IF zn >= leftpart THEN
   zoom = zn
ELSE
   zoom = leftpart
END IF

v = 5

VIEW (400, 10)-(420, 435), , 8

   CLS
   WINDOW (0, 0)-(25, zoom)
   LINE (v, 0)-(v, xn), 7
   LINE (v, xn)-(v, xn + yn), 6
   v = v + 5
   LINE (v, 0)-(v, zn), 4
   v = v + 5

zoom = area.w

   WINDOW (0, 0)-(25, zoom)
   LINE (v, 0)-(v, area.r), 7
   LINE (v, area.r)-(v, area.r + area.l), 6
   v = v + 5
   LINE (v, 0)-(v, area.w), attr.ratio.p
VIEW (0, 0)-(235, 479)

END SUB

SUB cor.01.prt

COLOR (8)
LOCATE 1, 57: PRINT "correlations"

'cor.01
LOCATE 56, 48: PRINT "xn+yn"
LOCATE 57, 51: PRINT "zn"
LOCATE 58, 48: PRINT "al+ar"
LOCATE 59, 51: PRINT "aw"

'cor.02
LOCATE 56, 55: PRINT "hl"
LOCATE 57, 55: PRINT "hw"
LOCATE 58, 55: PRINT "hr"

'cor.03
LOCATE 56, 58: PRINT "s1"
LOCATE 57, 58: PRINT "b "
LOCATE 58, 58: PRINT "s2"
LOCATE 59, 58: PRINT "s3"

'cor.04
LOCATE 56, 62: PRINT "s4"
LOCATE 57, 62: PRINT "b "
LOCATE 58, 62: PRINT "s5"
LOCATE 59, 62: PRINT "s6"

'cor.05
LOCATE 56, 66: PRINT "  "
LOCATE 57, 66: PRINT "  "
LOCATE 58, 66: PRINT "  "
LOCATE 59, 66: PRINT "  "

'cor.07
LOCATE 56, 74: PRINT "s1"
LOCATE 57, 74: PRINT "s2"

'cor.08
LOCATE 56, 77: PRINT "s2"
LOCATE 57, 77: PRINT "s1"
LOCATE 58, 77: PRINT "dS"

END SUB

SUB cor.02

IF hyp.w >= hyp.l AND hyp.w >= hyp.r THEN
   zoom = hyp.w
ELSE
   IF hyp.l >= hyp.w AND hyp.l >= hyp.r THEN
      zoom = hyp.l
   ELSE
      zoom = hyp.r
   END IF
END IF

v = 5

VIEW (430, 10)-(450, 435), , 8
   CLS
   WINDOW (0, 0)-(25, zoom)
   LINE (v, 0)-(v, hyp.l), attr.h.p
   v = v + 5
   LINE (v, 0)-(v, hyp.w), attr.h.p
   v = v + 5
   LINE (v, 0)-(v, hyp.r), attr.h.p
VIEW (0, 0)-(235, 479)

END SUB

SUB cor.03

IF targ# >= sign(1) AND targ# >= sign(2) AND targ# >= sign(3) THEN
   zoom = targ#
ELSE
   IF sign(1) >= sign(2) AND sign(1) >= sign(2) THEN
      zoom = sign(1)
   ELSE
      IF sign(2) >= sign(1) AND sign(2) >= sign(3) THEN
         zoom = sign(2)
      ELSE
         zoom = sign(3)
      END IF
   END IF
END IF

v = 5

VIEW (460, 10)-(480, 435), , 8
   CLS
   WINDOW (0, 0)-(25, zoom)

   LINE (v, 0)-(v, sign(1)), attr.ratio.p
   v = v + 5
   LINE (v, 0)-(v, targ#), attr.ratio.p
   v = v + 5
   LINE (v, 0)-(v, sign(2)), attr.ratio.p
   v = v + 5
   LINE (v, 0)-(v, sign(3)), attr.ratio.p

VIEW (0, 0)-(235, 479)

END SUB

SUB cor.04

IF targ# >= sign(4) AND targ# >= sign(5) AND targ# >= sign(6) THEN
   zoom = targ#
ELSE
   IF sign(4) >= sign(5) AND sign(4) >= sign(6) THEN
      zoom = sign(4)
   ELSE
      IF sign(5) >= sign(4) AND sign(5) >= sign(6) THEN
         zoom = sign(5)
      ELSE
         zoom = sign(6)
      END IF
   END IF
END IF

v = 5

VIEW (490, 10)-(510, 435), , 8

   CLS
   WINDOW (0, 0)-(25, zoom)

   LINE (v, 0)-(v, targ#), attr.ratio.p
   v = v + 5
   LINE (v, 0)-(v, sign(4)), attr.ratio.p
   v = v + 5
   LINE (v, 0)-(v, sign(5)), attr.ratio.p
   v = v + 5
   LINE (v, 0)-(v, sign(6)), attr.ratio.p

VIEW (0, 0)-(235, 479)

END SUB

SUB cor.05

zoom# = 0
FOR j% = 7 TO 9
   IF sign(j%) + sign(j% + 6) > zoom# THEN zoom# = sign(j%) + sign(j% + 6)
NEXT
FOR j% = 10 TO 12
   IF sign(j%) > zoom# THEN zoom# = sign(j%)
NEXT

v = 5

VIEW (520, 10)-(580, 435), , 8
   CLS
   WINDOW (0, 0)-(50, zoom#)

   LINE (v, 0)-(v, sign(7)), attr.ratio.p + 3
   LINE (v, sign(7))-(v, sign(7) + sign(13)), attr.ratio.p
   v = v + 5
   LINE (v, 0)-(v, sign(8)), attr.ratio.p + 3
   LINE (v, sign(8))-(v, sign(8) + sign(14)), attr.ratio.p
   v = v + 5
   LINE (v, 0)-(v, sign(9)), attr.ratio.p + 3
   LINE (v, sign(9))-(v, sign(9) + sign(15)), attr.ratio.p
   v = v + 5

   LINE (v, 0)-(v, sign(10)), attr.ratio.p
   v = v + 5
   LINE (v, 0)-(v, sign(11)), attr.ratio.p
   v = v + 5
   LINE (v, 0)-(v, sign(12)), attr.ratio.p
'   v = v + 5

VIEW (0, 0)-(235, 479)

END SUB

SUB cor.07

v = 5
IF sign(1) = targ# AND sign(2) = targ# THEN
   zoom = 1
ELSE
   IF sign(1) > sign(2) THEN
      zoom = dSign2
   ELSE
      zoom = dSign1
   END IF
END IF

VIEW (585, 10)-(600, 435), , 8
   WINDOW (0, 0)-(15, zoom)
   CLS

   LINE (v, 0)-(v, dSign2), attr.ratio.p
   v = v + 5
   LINE (v, 0)-(v, dSign1), attr.ratio.p

VIEW (0, 0)-(235, 479)

END SUB

SUB cor.08

IF sign(1) = targ# AND sign(2) = targ# THEN
   zoom = 1
ELSE
   IF sign(1) > sign(2) THEN
      zoom = dSign2
   ELSE
      zoom = dSign1
   END IF
END IF
v = 5

VIEW (605, 10)-(620, 435), , 8
   WINDOW (0, -zoom)-(15, zoom)
   CLS
   LINE (0, 0)-(15, 0), 8

   LINE (v, 0)-(v, dSign1), attr.ratio.p
   v = v + 5
   LINE (v, 0)-(v, -dSign2), attr.ratio.p

VIEW (0, 0)-(235, 479)

END SUB

SUB cor.09

xscale = 114
VIEW (400, 10)-(600, 435), , 8

   WINDOW (0, 0)-(xscale, 1)
   LINE (y + v, 0)-(y + v, 10), 0
   LINE (0, targ#)-(xscale, targ#), 8
   LINE (y + v, 0)-(y + v, sign(1)), attr.ratio.p
   v = v + 5
   'delay                                      'use if you have a fast machine
   LINE (y + v, 0)-(y + v, 10), 0
   LINE (y + v, 0)-(y + v, sign(2)), attr.ratio.p
   v = v + 5

   sign1.sav = sign(1)
   sign2.sav = sign(2)

VIEW (0, 0)-(235, 479)
COLOR (8)

END SUB

SUB cor.09.prt

LOCATE 1, 57: COLOR (8): PRINT "correlations"
LOCATE 56, 51: PRINT "s1 s2 s1 s2..."

END SUB

SUB cor.0a

STATIC sign1.sav, sign2.sav
v = 5: zoom = 2

VIEW (460, 10)-(480, 435), , 8
WINDOW (0, 0)-(20, zoom)

delay
PSET (v, sign1.sav), 0
delay
PSET (v, sign(1)), 15
sign1.sav = sign(1)
v = v + 5

delay
PSET (v, targ#), 10
v = v + 5

PSET (v, sign2.sav), 0
delay
PSET (v, sign(2)), 15
sign2.sav = sign(2)
delay

VIEW (0, 0)-(398, 450)

END SUB

SUB cor.10

SELECT CASE finish%

   CASE IS = 5
      xscale = 35
   CASE IS = 10
      xscale = 65
   CASE IS = 15
      xscale = 95
   CASE IS = 20
      xscale = 125
   CASE ELSE
      xscale = 125

END SELECT

VIEW (400, 10)-(600, 435), , 8

   WINDOW (0, 0)-(xscale, 2)

   LINE (0, targ#)-(xscale / 25, targ#), 8
   LINE (xscale, targ#)-(xscale - (xscale / 25), targ#), 8

   LINE (y + v, 0)-(y + v, 2), 0
   PSET (y + v, sign(1)), 12
'   delay                                      'use if you have a fast machine

   PSET (y + v, sign(2)), attr.ratio.p + 8
'   delay

   sign1.0(y, 1) = y + v: sign1.0(y, 2) = sign(1)
   sign2.0(y, 1) = y + v: sign2.0(y, 2) = sign(2)

   dSign1.0(y, 1) = y + v: dSign1.0(y, 2) = dSign1
   dSign2.0(y, 1) = y + v: dSign2.0(y, 2) = dSign2

   COLOR (8)

'   VIEW (1, 190)-(235, 210), , 8
   IF dSign1 < dSign1.min THEN
      dSign1.min = dSign1
      LOCATE 25, 7: PRINT "                            "
      LOCATE 25, 2: PRINT "mS1 ="; dSign1.min
   END IF
   IF dSign2 < dSign2.min THEN
      dSign2.min = dSign2
      LOCATE 26, 7: PRINT "                            "
      LOCATE 26, 2: PRINT "mS2 ="; dSign2.min
   END IF
   'PauseQ

   v = v + 5

VIEW (0, 0)-(235, 479)
COLOR (8)

END SUB

SUB cor.10.prt

LOCATE 1, 57: COLOR (8): PRINT "correlations"
LOCATE 56, 51: COLOR (4): PRINT "s1 "; : COLOR (7): PRINT "s2..."

END SUB

SUB delay

'this routine is used to smoothe out the annimation in the Ani.cor.1 step
'modeled on the prime-number seive in Microsoft QBasic 4.5 Help

STATIC UNMARK
DIM Mark(10000)

MARKIT = NOT UNMARK
start! = TIMER

Num = 0
FOR d = 3 TO 4 STEP 2

   IF NOT Mark(d) THEN
      Delta = 2 * d

      'increase or decrease the "TO" number to adjust the animation to the
      'speed of your computer (1 < "TO" < 10000 - or increase arraysize above)

      FOR i = 3 * d TO 1000 STEP Delta
         Mark(i) = MARKIT
      NEXT

      Num = Num + 1

   END IF
NEXT

END SUB

SUB delayit

FOR j% = 1 TO 10
   delay
NEXT

END SUB

SUB Explore03

'short looks ----- comment out the 'if' statement in the loop
'n = 1: start% = 1: finish% = 5
n = 2: start% = 2: finish% = 5
'n = 3: start% = 2: finish% = 5
'n = 4: start% = 2: finish% = 5
'n = 5: start% = 2: finish% = 5

'midlin' looks
'n = 1: start% = 1: finish% = 25
'n = 2: start% = 2: finish% = 25
'n = 3: start% = 2: finish% = 25

'longer looks
'n = 1: start% = 1: finish% = 100
'n = 2: start% = 2: finish% = 100
'n = 3: start% = 2: finish% = 100

'start% = 1: finish% = 5
'FOR n = start% TO finish%
FOR z = start% TO finish%
   FOR x = start% TO finish%
      FOR y = start% TO finish%

      calc00
      ' comment out the following statement while looking at all instances
'      IF leftpart = zn THEN
         PauseQ
         CLS
         calcHyp
         calcSign
         prt.XYZN
         prt.hyp
         prt.Target
         prt.zRatio
         prt.iteration
         VIEW (240, 60)-(395, 215), , 8
            AS.Graph01
         cor.01
         cor.02
         cor.03
         cor.04
         cor.05
         cor.07
         cor.08
         cor.01.prt
      ' comment out the following statement while looking at all instances
'      END IF

      NEXT
   NEXT
NEXT
'NEXT
PauseQ
END SUB

SUB Explore04

iteration = 0

start% = 1: finish% = 5

FOR n = start% TO finish%
   COLOR (8): LOCATE 2, 22: PRINT "n ="; n: COLOR (7)

   FOR z = start% TO finish%
      FOR x = start% TO finish%
         FOR y = start% TO finish%

         calc00
         calcHyp
         calcSign
         VIEW (240, 60)-(395, 215), , 8
            AS.Graph01
         cor.01
         cor.02
         cor.03
         cor.04
         cor.05
         cor.07
         cor.08
         cor.01.prt

         IF leftpart = zn THEN
            prt.XYZN
            prt.hyp
            prt.Target
            prt.zRatio
            prt.iteration
            PauseQ
            CLS
            cor.01.prt
         END IF

         NEXT
      NEXT
   NEXT
NEXT

PauseQ

END SUB

SUB Graph01

'quick look
'n = 3: xscayl& = 1000: yscayl& = 5: start% = 1: finish% = 10
'n = 3: xscayl& = 1000: yscayl& = 1: start% = 1: finish% = 10
n = 2: xscayl& = 1000: yscayl& = 5: start% = 1: finish% = 10
'n = 2: xscayl& = 1000: yscayl& = 1: start% = 1: finish% = 10
'n = 1: xscayl& = 100: yscayl& = 5: start% = 1: finish% = 10
'n = 1: xscayl& = 100: yscayl& = 1: start% = 1: finish% = 10

'long look
'n = 3: xscayl& = 20000: yscayl& = 1: start% = 1: finish% = 25
'n = 3: xscayl& = 2000: yscayl& = 25: start% = 1: finish% = 25
'n = 2: xscayl& = 16000: yscayl& = 50: start% = 1: finish% = 25
'n = 2: xscayl& = 2000: yscayl& = 50: start% = 1: finish% = 25
'n = 1: xscayl& = 600: yscayl& = 10: start% = 1: finish% = 25

WINDOW (0, 0)-(xscayl&, yscayl&)

CLS
iteration = 0
LINE (0, targ#)-(xscayl&, targ#), 8
PauseQ
FOR x = start% TO finish%
   FOR y = start% TO finish%
      FOR z = start% TO finish%

      calc00
      calcHyp
      calcSign
      IF leftpart = zn THEN PlotHi ELSE PlotLo
      IF iteration > xscayl& THEN EXIT FOR   'keep it on screen

      NEXT
   IF iteration > xscayl& THEN EXIT FOR
   NEXT
IF iteration > xscayl& THEN EXIT FOR
NEXT

PauseQ

END SUB

SUB Graph03

'use this X-Scale for the following sets of values --------------------------
xscayl& = 1100 'comment out other scales below ----------------  'quick look
'n = 3: yscayl& = 1: start% = 1: finish% = 10                    ' keeper
'n = 3: yscayl& = 50: start% = 1: finish% = 10                   ' keeper
'n = 3: xscayl& = 150: yscayl& = 5: start% = 1: finish% = 5      ' keeper
'n = 2: yscayl& = 1: start% = 1: finish% = 10                    ' keeper :-)
n = 2: xscayl& = 1000: yscayl& = 5: start% = 1: finish% = 10
'n = 2: yscayl& = 15: start% = 1: finish% = 10                   ' keeper
'n = 1: yscayl& = 1: start% = 1: finish% = 10                    ' keeper
'n = 1: yscayl& = 5: start% = 1: finish% = 10                    ' keeper :-)
'n = 1: xscayl& = 150: yscayl& = 4: start% = 1: finish% = 5      ' keeper

'use this X-Scale for the following sets of values --------------------------
'xscayl& = 16000                                                  'long look
'n = 5: yscayl& = 1: start% = 1: finish% = 25                    ' keeper :-)
'n = 5: yscayl& = 2: start% = 1: finish% = 25                    ' keeper
'n = 5: yscayl& = 250: start% = 1: finish% = 25                  ' keeper
'n = 5: yscayl& = 5000: start% = 1: finish% = 25                 ' keeper
'n = 4: yscayl& = 1: start% = 1: finish% = 25                    ' keeper
'n = 4: yscayl& = 250: start% = 1: finish% = 25                  ' keeper
'n = 3: yscayl& = 1: start% = 1: finish% = 25                    ' keeper
'n = 3: yscayl& = 250: start% = 1: finish% = 25                  ' keeper
'n = 2: yscayl& = 1: start% = 1: finish% = 25                    ' keeper :-)
'n = 2: yscayl& = 50: start% = 1: finish% = 25                   ' keeper :-)
'n = 1: yscayl& = 1: start% = 1: finish% = 25                    ' keeper :-)
'n = 1: yscayl& = 5: start% = 1: finish% = 25                    ' keeper :-)

WINDOW (0, 0)-(xscayl&, yscayl&)

CLS
LINE (0, targ#)-(xscayl&, targ#), 8                    'targ# = sin(45)
iteration = 0
PauseQ

FOR z = start% TO finish%
   FOR x = start% TO finish%
      FOR y = start% TO finish%

      calc00
      calcHyp
      calcSign

      'uncomment following line to pause at left = right
      'IF leftpart = zn THEN PlotHi: PauseQ ELSE PlotLo

      'comment following line if pausing at left = right
      IF leftpart = zn THEN PlotHi ELSE PlotLo


      IF iteration > xscayl& THEN EXIT FOR      'keep it on the screen
      NEXT

   IF iteration > xscayl& THEN EXIT FOR
   NEXT

IF iteration > xscayl& THEN EXIT FOR
NEXT

PauseQ

END SUB

SUB Graph04

zoom1 = -1000: zoom2 = 1000
GOSUB Graphit04
zoom1 = -100: zoom2 = 100
GOSUB Graphit04
zoom1 = -10: zoom2 = 10
GOSUB Graphit04
zoom1 = -4: zoom2 = 5
GOSUB Graphit04
zoom1 = 0: zoom2 = 2
GOSUB Graphit04
zoom1 = .9: zoom2 = 1.1
GOSUB Graphit04
zoom1 = .99: zoom2 = 1.01
GOSUB Graphit04
zoom1 = .999: zoom2 = 1.001
GOSUB Graphit04
zoom1 = .9999: zoom2 = 1.0001
GOSUB Graphit04
zoom1 = .99999: zoom2 = 1.00001
GOSUB Graphit04
zoom1 = .999999: zoom2 = 1.000001
GOSUB Graphit04
PauseQ
EXIT SUB

Graphit04:
WINDOW (0, zoom1)-(625, zoom2)
CLS : iteration = 0
COLOR (7): LOCATE 1, 1: PRINT "y scale = "; zoom1; "to"; zoom2
start% = 1: finish% = 5

FOR z = start% TO finish%
   FOR x = start% TO finish%
      FOR y = start% TO finish%
         FOR n = 5 TO 1 STEP -1

            calc00
            calcHyp
            calcSign

            PSET (iteration, targ#), 8
            PSET (iteration, sign(1)), n
            PSET (iteration, sign(2)), n

            IF sign(1) < -zoom1 AND sign(1) > zoom2 THEN EXIT FOR
         NEXT
         IF sign(1) < -zoom1 AND sign(1) > zoom2 THEN EXIT FOR
      NEXT
      IF sign(1) < -zoom1 AND sign(1) > zoom2 THEN EXIT FOR
   NEXT
   IF sign(1) < -zoom1 AND sign(1) > zoom2 THEN EXIT FOR
NEXT

PauseQ
RETURN

END SUB

SUB initialize

SCREEN 12: WIDTH 80, 60

'set special-event foreground colors

attr.z = 5: attr.h = 9: attr.n = 3: attr = 7: attr.ratio = 2: attr.eq = 4
attr.ws = 9: attr.hw = 6: attr.sl = 4: attr.sr = 3

targ# = 1

END SUB

FUNCTION Log10 (l#) STATIC

   Log10 = LOG(l#) / LOG(10#)

END FUNCTION

SUB Pause.Check
SHARED XX, YY, zz, nn, pausit

SELECT CASE pchoice

   CASE IS = 1
      'stop at all instances during loop - displays all numbers
      Pause.Look

   CASE IS = 2
      'pause and display all numbers at left = right
      IF leftpart = zn THEN Pause.Look

   CASE IS = 3
      'pause and display all numbers at left = right
      IF leftpart = zn THEN Pause.Look3

END SELECT

END SUB

SUB Pause.Look

prt.XYZN
prt.hyp
prt.Target
prt.zRatio
prt.iteration

PauseQ
VIEW (0, 0)-(235, 479)
CLS

END SUB

SUB Pause.Look2

prt.XYZN
prt.hyp
prt.iteration

PauseQ
VIEW (0, 0)-(235, 479)
CLS

END SUB

SUB Pause.Look3

prt.XYZN
prt.hyp
prt.Target
prt.Pyth
prt.iteration

PauseQ
VIEW (0, 0)-(235, 479)
CLS

END SUB

SUB PauseQ

    begin = 0
    COLOR 4: LOCATE 1, 79: PRINT "e"
114 a$ = INKEY$: IF a$ = "" THEN GOTO 114
    IF a$ = "B" OR a$ = "b" THEN begin = 1
    IF a$ = "C" OR a$ = "c" THEN CLS      ' ENTERING "C" CLEARS SCREEN
    IF a$ = "E" OR a$ = "e" THEN END      ' ENTERING "E" ENDS EXECUTION
    COLOR 0: LOCATE 1, 79: PRINT "e": COLOR 7

END SUB

SUB PlotHi

PSET (iteration, hyp.r), 12
PSET (iteration, sign(2)), 14

END SUB

SUB PlotLo

PSET (iteration, hyp.r), 8
PSET (iteration, sign(2)), 1

END SUB

SUB prt.hyp

IF hyp.l = hyp.r THEN attr = 2 ELSE attr = 7
COLOR (7)

PRINT
PRINT " left:"
PRINT " area ="; : COLOR (8): PRINT area.l: COLOR (7)
PRINT " side =";
COLOR (attr.sl)
PRINT side.l: COLOR (7)
PRINT "  hyp =";
COLOR (attr.h.p)
PRINT hyp.l: COLOR (7)
PRINT "  s/h ="; : COLOR (8): PRINT ratio.l: COLOR (7)

PRINT
PRINT "whole:"
PRINT " area ="; : COLOR (8): PRINT area.w: COLOR (7)
PRINT " side =";

IF side.w = side.l AND side.w = side.r THEN COLOR (attr.ratio.p)
PRINT side.w
COLOR (7)
PRINT "  hyp ="; : COLOR (attr.h.p): PRINT hyp.w; : COLOR (7)

IF hyp.w = n * z THEN
   PRINT "="; : COLOR (attr.n): PRINT n; : COLOR (7): PRINT "*"; : COLOR (attr.z): PRINT z: COLOR (7)
ELSE
   PRINT
END IF

PRINT "  s/h ="; : COLOR (8): PRINT ratio.w
COLOR (7)

PRINT
PRINT "right:"
PRINT " area =";
COLOR (8)
PRINT area.r
COLOR (7)
PRINT " side =";
COLOR (attr.sr)
PRINT side.r: COLOR (7)
PRINT "  hyp =";
COLOR (attr.h.p)
PRINT hyp.r: COLOR (7)
PRINT "  s/h ="; : COLOR (8): PRINT ratio.r: COLOR (7)
PRINT
PRINT " sl^2 ="; side.l ^ 2
PRINT " sw^2 ="; side.w ^ 2
PRINT " sr^2 ="; side.r ^ 2

END SUB

SUB prt.iteration

PRINT
PRINT "cycle ="; iteration
COLOR (7)

END SUB

SUB prt.Pyth

i = x ^ n
j = y ^ n
k = z ^ n

l = SQR((i ^ 2) + (j ^ 2))

PRINT
PRINT "     i = x^n ="; i
PRINT "     j = z^n ="; j
PRINT "     k = z^n ="; k
PRINT
PRINT "sqr(i^2+j^2) = "; l

EXIT SUB

SELECT CASE n

   CASE IS = 1
      xscale = 10
   CASE IS = 2
      xscale = 35
   CASE IS = 3
      xscale = 250
   CASE IS = 4
      xscale = 800
   CASE ELSE
      xscale = 5000

END SELECT

VIEW (240, 10)-(415, 435), , 8
   WINDOW (-.1, 0)-(xscale, 25)
   IF leftpart = zn THEN attr = 12 ELSE attr = 7
   PSET (l, iteration), attr

END SUB

SUB prt.Target

PRINT
PRINT "hl/hw =";
COLOR (attr.ratio.p)
PRINT sign(1)
COLOR (7)

PRINT "diffl =";
COLOR (attr.ratio.p)
PRINT dSign1
COLOR (7)

PRINT " base =";
COLOR (attr.ratio.p)
PRINT targ#
COLOR (7)

PRINT "diffr =";
COLOR (attr.ratio.p)
PRINT dSign2
COLOR (7)

PRINT "hr/hw =";
COLOR (attr.ratio.p)
PRINT sign(2)
COLOR (7)
PRINT
PRINT "(RH/WH)/(LH/WH):"
COLOR (attr.ratio.p)
PRINT "       "; sign(3)
COLOR (7)
PRINT "hl/hr =";
COLOR (attr.ratio.p)
PRINT sign(5)
COLOR (7)
PRINT "hr/hl =";
COLOR (attr.ratio.p)
PRINT sign(6)
COLOR (7)

END SUB

SUB prt.XYZN

IF leftpart = zn THEN eqneq$ = "=": attr = attr.eq ELSE eqneq$ = "<>": attr = 7

COLOR (7)
LOCATE 2, 1: PRINT "x ="; x
LOCATE 2, 8: PRINT "y ="; y
LOCATE 2, 15: PRINT "z ="; : COLOR (attr.z): PRINT z; : COLOR (7)
LOCATE 2, 22: PRINT "n ="; : COLOR (attr.n): PRINT n: COLOR (7)

LOCATE 3, 1: PRINT "(x^n + y^n) ="; leftpart
PRINT "z^n ="; zn
PRINT xn; "+"; yn; eqneq$;
COLOR (attr)
PRINT zn
COLOR (7)
PRINT leftpart; eqneq$;
COLOR (attr)
PRINT zn
COLOR (7)

END SUB

SUB prt.XYZN2
SHARED XX, YY, zz, nn

VIEW (0, 0)-(295, 40)

COLOR (7)
LOCATE 2, 1: PRINT "x ="; XX
LOCATE 2, 10: PRINT "y ="; YY
LOCATE 2, 19: PRINT "z ="; : COLOR (attr.z): PRINT zz; : COLOR (7)
LOCATE 2, 28: PRINT "n ="; : COLOR (attr.n): PRINT nn: COLOR (7)

LOCATE 4, 1: PRINT "(x^n + y^n) ="; (XX ^ nn + YY ^ nn)
LOCATE 5, 1: PRINT "        z^n ="; zz ^ nn

END SUB

SUB prt.XYZN3

IF leftpart = zn THEN eqneq$ = "=": attr = attr.eq ELSE eqneq$ = "<>": attr = 7

COLOR (7)
LOCATE 2, 1: PRINT "x =";
COLOR (4)
PRINT x
COLOR (7)
LOCATE 2, 8: PRINT "y =";
COLOR (3)
PRINT y
COLOR (7)
LOCATE 2, 15: : PRINT "z ="; : COLOR (2): PRINT z; : COLOR (7)
LOCATE 2, 22: PRINT "n ="; n

LOCATE 3, 1: PRINT "(x^n + y^n) ";
COLOR (attr)
PRINT "=";
COLOR (7)
PRINT leftpart
PRINT "z^n ";
COLOR (attr)
PRINT "=";
COLOR (5)
PRINT zn
COLOR (7)
PRINT xn; "+"; yn;
COLOR (attr)
PRINT eqneq$;
COLOR (7)
PRINT zn
COLOR (7)
PRINT leftpart;
COLOR (attr)
PRINT eqneq$;
COLOR (5)
PRINT zn
COLOR (7)

END SUB

SUB prt.zRatio

PRINT
PRINT " x/hl ="; sign(7)
PRINT " x/hr ="; sign(8)
PRINT " x/hw ="; sign(9)
PRINT
PRINT " z/hl ="; sign(10)
PRINT " z/hr ="; sign(11)
PRINT " z/hw ="; sign(12)
PRINT
PRINT "s7+s13="; sign(7) + sign(13)
PRINT
PRINT " y/hl ="; sign(13)
PRINT " y/hr ="; sign(14)
PRINT " y/hw ="; sign(15)

COLOR (7)

END SUB

